
COMPort_Number = 4;
NEW_IMAGE_FLAG = hex2dec('AC');
CONFIRMATON_FLAG = hex2dec('BE');
NUM_LINES = 128;
NUM_HORIZ_PIXELS = 128;
NUM_BYTES_PER_LINE = 16;
LINES_PER_PACKET = 4;

ImageFilename = uigetfile(["*.bmp"]);

CurrentImage = ReadImage(ImageFilename);

CurrentImage = SegmentByThreshold(CurrentImage, 254);

PixelData = uint8(zeros(NUM_LINES, NUM_BYTES_PER_LINE));

for row = 1:NUM_LINES
    bit_position = 8;
    column_byte = 1;
    for column = 1:NUM_HORIZ_PIXELS
        if (CurrentImage(row,column) == %T) then
            PixelData(row, column_byte) = bitset(PixelData(row, column_byte), bit_position, 1);
        else
            PixelData(row, column_byte) = bitset(PixelData(row, column_byte), bit_position, 0);
        end
        bit_position = bit_position - 1;
        if bit_position == 0 then
            bit_position = 8;
            column_byte = column_byte + 1;
        end
    end
end

PixelData = double(PixelData);

ShowImage(CurrentImage, 'Gray Level Image');

cd "C:\Program Files\scilab-5.5.2\";

exec("C:\Program Files\scilab-5.5.2\slLoadLib.sci");

clc();

EFM8Port = slMount();

slConfig(EFM8Port, 115200, 8, 0, 1);

return_val = slOpen(EFM8Port, COMPort_Number);

if return_val == 0 then
    printf("Unable to open COM port %d\n", COMPort_Number)
    slUMount(EFM8Port);
    slUnload();
    abort
end

tic();    

slSendByte(EFM8Port, NEW_IMAGE_FLAG);

response = slReadByte(EFM8Port, 1);

if response  ~= NEW_IMAGE_FLAG then
    printf("Incorrect response\n");
    slClose(EFM8Port);
    slUMount(EFM8Port);
    slUnload();
    abort
end

for n = 1:LINES_PER_PACKET:(NUM_LINES-(LINES_PER_PACKET-1))
    BytestoSend = PixelData(n:n+(LINES_PER_PACKET-1), :);
    BytestoSend = matrix(BytestoSend', 1, (LINES_PER_PACKET*NUM_BYTES_PER_LINE));
    
    slSendArray(EFM8Port, BytestoSend, length(BytestoSend));
    
    response = slReadByte(EFM8Port, 1);
    if response  ~= CONFIRMATON_FLAG then
        printf("Incorrect response\n");
        slClose(EFM8Port);
        slUMount(EFM8Port);
        slUnload();
        abort
    end
end

printf("%f seconds\n", toc());

slClose(EFM8Port);
slUMount(EFM8Port);
slUnload();


